           .386
           assume cs:_code, ds:_code

;
; The Externals
include misc.inc
;
_Data  Segment Para Public 'Data' use16
parameters	byte 128 dup (0),24h

usage		byte 0dh,0ah
		byte 'MAKEDPF Version 1.0',0dh,0ah
		byte 'Written by Danny Dulai',0dh,0ah,0ah
		byte 'Usage: MAKEDPF <filename>',0dh,0ah,0ah
		byte '     Makes a DPF file',0dh,0ah,24h

header		byte	'DPF'
		byte	0		;version 1
		byte	8		;width
		byte	8		;height
		byte	95		;number of chars
		byte	32		;starting ascii char
		byte	0		;0=mono, 1=color
		byte	7 dup (0)	;reserved

ask1		byte	0ah,0dh,'Width: $'
ask2		byte	0ah,0dh,'Height: $'
ask3		byte	0ah,0dh,'Number of characters: $'
ask4		byte	0ah,0dh,'Starting character: $'

noram		byte	'Not enough memory!$'
nofile		byte	'File not found: $'

_Data  EndS

;
_stack     segment stack 'stack' use16
           db 1024 dup (0)
_stack     ends

_code      segment use16
           assume cs:_code, ds:_data

data1	word	?
vram	word	0a000h
font	word	0

getparameters proc
	mov	ah,51h
	int	21h
	mov	es,bx
	mov	di,80h
	.IF BYTE PTR ES:[DI] == 0
		stc
		ret
	.ENDIF
	lea	si,parameters

	xor	cx,cx
	mov	cl,es:[di]

	.REPEAT
		inc	di
		mov	al,es:[di]
	.UNTIL (AL != 20h) && (AL != 0)

	.IF AL == 0DH
		stc
		ret
	.ENDIF

	.REPEAT
		mov	al,es:[di]
		.BREAK .IF (AL == 0DH) || (AL == 0) || (AL == 20H)
		.IF (AL >= 'a') && (AL <= 'z')
			sub	al,20h
		.ENDIF
		mov	ds:[si],al
		inc	di
		inc	si
	.UNTILCXZ
	mov	byte ptr [si],0

	sub	si,4
	.IF BYTE PTR [SI] != '.'
		add	si,4
		mov	byte ptr [si],'.'
		inc	si
		mov	byte ptr [si],'F'
		inc	si
		mov	byte ptr [si],'N'
		inc	si
		mov	byte ptr [si],'T'
		inc	si
		mov	byte ptr [si],0
		inc	si
	.ENDIF

	clc
	ret
getparameters endp

start proc
	mov	ah,4ah
	mov	bx,64*128
	int	21h
	mov	ax,_data
	mov	ds,ax
	mov	cs:data1,ax
	mov	ax,_stack
	mov	ss,ax

	call	getparameters
	.IF CARRY?
		prstr	usage
		exit	1
	.ENDIF	

	alloc	cs:font,4096

	fopen	parameters
	mov	ds,cs:font
	fread	0,-1
	mov	ds,cs:data1
	fclose

	prstr	ask1
	xor	ah,ah
	mov	al,header[4]
	deciprno	ax
	putch 8
	putch 8
	putch 8
	putch 8
	.REPEAT
		xor	cx,cx
		mov	ah,0
		int	16h
		.IF (AH == 48h) || (AH == 4dh)
			inc	byte ptr header[4]
		.ELSEIF (AH == 50h) || (AH == 4bh)
			dec	byte ptr header[4]
		.ELSEIF AH == 1ch
			inc	cx
		.ENDIF
		xor	ah,ah
		mov	al,header[4]
		deciprno	ax
		putch 8
		putch 8
		putch 8
		putch 8
	.UNTIL CX
	xor	ah,ah
	mov	al,header[4]
	deciprno	ax

	prstr	ask2
	xor	ah,ah
	mov	al,header[5]
	deciprno	ax
	putch 8
	putch 8
	putch 8
	putch 8
	.REPEAT
		xor	cx,cx
		mov	ah,0
		int	16h
		.IF (AH == 48h) || (AH == 4dh)
			inc	byte ptr header[5]
		.ELSEIF (AH == 50h) || (AH == 4bh)
			dec	byte ptr header[5]
		.ELSEIF AH == 1ch
			inc	cx
		.ENDIF
		xor	ah,ah
		mov	al,header[5]
		deciprno	ax
		putch 8
		putch 8
		putch 8
		putch 8
	.UNTIL CX
	xor	ah,ah
	mov	al,header[5]
	deciprno	ax

	prstr	ask3
	xor	ah,ah
	mov	al,header[6]
	deciprno	ax
	putch 8
	putch 8
	putch 8
	putch 8
	.REPEAT
		xor	cx,cx
		mov	ah,0
		int	16h
		.IF (AH == 48h) || (AH == 4dh)
			inc	byte ptr header[6]
		.ELSEIF (AH == 50h) || (AH == 4bh)
			dec	byte ptr header[6]
		.ELSEIF AH == 1ch
			inc	cx
		.ENDIF
		xor	ah,ah
		mov	al,header[6]
		deciprno	ax
		putch 8
		putch 8
		putch 8
		putch 8
	.UNTIL CX
	xor	ah,ah
	mov	al,header[6]
	deciprno	ax

	prstr	ask4
	xor	ah,ah
	mov	al,header[7]
	deciprno	ax
	putch 8
	putch 8
	putch 8
	putch 8
	.REPEAT
		xor	cx,cx
		mov	ah,0
		int	16h
		.IF (AH == 48h) || (AH == 4dh)
			inc	byte ptr header[7]
		.ELSEIF (AH == 50h) || (AH == 4bh)
			dec	byte ptr header[7]
		.ELSEIF AH == 1ch
			inc	cx
		.ENDIF
		xor	ah,ah
		mov	al,header[7]
		deciprno	ax
		putch 8
		putch 8
		putch 8
		putch 8
	.UNTIL CX
	xor	ah,ah
	mov	al,header[7]
	deciprno	ax

	mov	al,header[4]
	dec	al
	shr	al,3
	inc	al
	mul	header[5]
	.IF HEADER[6]
		mul	header[6]
	.ELSE
		shl	ax,8
	.ENDIF
	push	ax


	fcreate	parameters
	fwrite	header,16
	mov	ds,cs:font
	pop	cx
	fwrite	0,cx
	fclose

quit:	mov	ah,4ch
	int	21h
start endp

_code ends
end start
