           .386
           assume cs:_code, ds:_code

;
; The Externals
include misc.inc
;
_Data  Segment Para Public 'Data' use16
parameters	byte 128 dup (0),24h

usage		byte 0dh,0ah
		byte 'SHOWDPF Version 1.0',0dh,0ah
		byte 'Written by Danny Dulai',0dh,0ah,0ah
		byte 'Usage: SHOWDPF <filename>',0dh,0ah,0ah
		byte '     Shows a DPF file',0dh,0ah,24h

noram		byte	'Not enough memory!$'
nofile		byte	'File not found: $'
invalidfile	byte	'Invalid file$'

textfontw	byte	?
textfontwbytes	byte	?
textfonth	byte	?
textfontstart	byte	?
textfontend	byte	?

textx		word	0
texty		word	0

clr1		byte	15

_Data  EndS

;
_stack     segment stack 'stack' use16
           db 1024 dup (0)
_stack     ends

_code      segment use16
           assume cs:_code, ds:_data

data1	word	?
vram	word	0a000h
font	word	0

getparameters proc
	mov	ah,51h
	int	21h
	mov	es,bx
	mov	di,80h
	.IF BYTE PTR ES:[DI] == 0
		stc
		ret
	.ENDIF
	lea	si,parameters

	xor	cx,cx
	mov	cl,es:[di]

	.REPEAT
		inc	di
		mov	al,es:[di]
	.UNTIL (AL != 20h) && (AL != 0)

	.IF AL == 0DH
		stc
		ret
	.ENDIF

	.REPEAT
		mov	al,es:[di]
		.BREAK .IF (AL == 0DH) || (AL == 0) || (AL == 20H)
		.IF (AL >= 'a') && (AL <= 'z')
			sub	al,20h
		.ENDIF
		mov	ds:[si],al
		inc	di
		inc	si
	.UNTILCXZ
	mov	byte ptr [si],0

	sub	si,4
	.IF BYTE PTR [SI] != '.'
		add	si,4
		mov	byte ptr [si],'.'
		inc	si
		mov	byte ptr [si],'D'
		inc	si
		mov	byte ptr [si],'P'
		inc	si
		mov	byte ptr [si],'F'
		inc	si
		mov	byte ptr [si],0
		inc	si
	.ENDIF

	clc
	ret
getparameters endp

start proc
	mov	ah,4ah
	mov	bx,64*128
	int	21h
	mov	ax,_data
	mov	ds,ax
	mov	cs:data1,ax
	mov	ax,_stack
	mov	ss,ax

	call	getparameters
	.IF CARRY?
		prstr	usage
		exit	1
	.ENDIF	

	alloc	cs:font,4096

	fopen	parameters
	mov	ds,cs:font
	fread	0,-1
	fclose

	mov	ds,cs:data1
	mov	es,cs:font

	xor	si,si
	mov	ah,es:[si]
	mov	al,es:[si+1]
	mov	bh,es:[si+2]
	mov	bl,es:[si+3]

	.IF !((AH == 'D') && (AL == 'P') && (BH == 'F') && (BL == 0))
		prstr	invalidfile
		exit	1
	.ENDIF

	mov	al,es:[si+4]
	mov	textfontw,al
	mov	al,es:[si+5]
	mov	textfonth,al
	mov	al,textfontw
	dec	al
	shr	al,3
	inc	al
	mov	textfontwbytes,al

	mov	al,es:[si+7]
	mov	textfontstart,al
	add	al,es:[si+6]
	mov	textfontend,al

	mode	13h
	mov	es,cs:vram
	mov	al,32
	mov	bp,10
	.REPEAT
		mov	cx,10
		.REPEAT
			call	prfontchar
			inc	al
			dec	cx
		.UNTIL ZERO?
		mov	dl,textfonth
		xor	dh,dh
		add	texty,dx
		mov	textx,0
		dec	bp
	.UNTIL ZERO?


	mov	al,'T'
	call	prfontchar
	mov	al,'h'
	call	prfontchar
	mov	al,'a'
	call	prfontchar
	mov	al,'n'
	call	prfontchar
	mov	al,'x'
	call	prfontchar

getch


	mode	3
quit:	mov	ah,4ch
	int	21h
start endp

prfontchar proc
	pusha
	mov	ah,textfontstart
	.IF (TEXTFONTEND != AH)
		.IF ((AL > TEXTFONTEND) || (AL < AH))
			mov	al,textfontw
			xor	ah,ah
			add	textx,ax
			popa
			ret
		.ENDIF
	.ENDIF
	push	fs

	sub	al,textfontstart

	mov	ah,textfontwbytes
	mul	ah
	mul	textfonth
	add	ax,16
	mov	si,ax

	mov	ax,320
	mul	texty
	add	ax,textx
	mov	di,ax

	mov	bl,clr1
	mov	fs,cs:font
	mov	ch,textfonth
	.REPEAT
		push	di
		mov	cl,textfontwbytes
		.REPEAT
			mov	al,fs:[si]
			inc	si
			mov	bh,8
			.REPEAT
				rol	al,1
				.IF AL & 1
					mov	es:[di],bl
				.ENDIF
				inc	di
				dec	bh
			.UNTIL ZERO?
			dec	cl
		.UNTIL ZERO?
		pop	di
		add	di,320
		dec	ch
	.UNTIL ZERO?
	mov	al,textfontw
	xor	ah,ah
	add	textx,ax
	pop	fs
	popa
	ret
prfontchar endp

_code ends
end start
